// Copyright 1998-2014 Epic Games, Inc. All Rights Reserved.
#pragma once
#include "GameFramework/GameMode.h"
#include "SpawnVolume.h"
#include "TutorialCodeGameMode.generated.h"

// Enum to store the current state of gameplay.
enum class ETutorialCodePlayState : uint8
{
	EPlaying,
	EGameOver,
	EUnknown
};

UCLASS(minimalapi)
class ATutorialCodeGameMode : public AGameMode
{
	GENERATED_UCLASS_BODY()

	virtual void Tick(float DeltaSeconds) override;

	UPROPERTY(EditDefaultsOnly, BlueprintReadWrite, Category = Power)
	float DecayRate;

	ETutorialCodePlayState GetCurrentState() const;

	void SetCurrentState(ETutorialCodePlayState NewState);

	virtual void BeginPlay() override;

private:

	TArray<ASpawnVolume*> SpawnVolumeActors;

	ETutorialCodePlayState CurrentState;

	void HandleNewState(ETutorialCodePlayState NewState);
};

FORCEINLINE ETutorialCodePlayState ATutorialCodeGameMode::GetCurrentState() const
{
	return CurrentState;
}
